#include "stdafx.h"
#include "MapClasses.h"

#ifdef _DEBUG
static const int nTime = 30;
#else
static const int nTime = 3000;
#endif

int CMapBase::BenchInsert(const std::vector<std::string>& arykey)
{
	int nCount = 0;
	CPassCounter c;
	c.Start();
	while( c.GetCount()<nTime ){
		OnClear();
		for(std::vector<std::string>::const_iterator i=arykey.begin(); i!=arykey.end() && c.GetCount()<nTime; i++ ){
			OnInsert((*i),nCount);
#ifdef _DEBUG
			{
				int n;
				ASSERT( OnFind((*i),n) && n==nCount );
			}
#endif
			nCount++;
		}
	}
	return nCount;
}

int CMapBase::BenchFind(const std::vector<std::string>& arykey)
{
	int nCount = 0;
	{
		OnClear();
		{
			int n=0;
			for(std::vector<std::string>::const_iterator i=arykey.begin(); i!=arykey.end(); i++,n++ ) OnInsert((*i),n);
		}
		int nValue;
		CPassCounter c;
		c.Start();
		while( c.GetCount()<nTime ){
			for(std::vector<std::string>::const_iterator i=arykey.begin(); i!=arykey.end() && c.GetCount()<nTime; i++ ){
				bool b = OnFind((*i),nValue);
				nCount++;
			}
		}
	}
	return nCount;
}
